#pragma once

#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_sf.h>
#include "function.h"

// ⺻ 5000 ͸ ϴ ҷͼ Ѵ. 
#define MAX_Y		15000

class BayesDensityParam
{
public:
	BayesDensityParam()
	{

	}
	BayesDensityParam(int nr_data)
	{
		n = nr_data;
		step = 0;
	}
	~BayesDensityParam();

	// Ķ ʱȭ 
	void init()
	{
		// ͸ loadߴ  
		data_loaded = false;

		// Default parameter   
		dft = true;

		// n  ٸ ʱȭ Ѵ. 
		K = 10;
		alpha = n / 100.0;

		m = 0.0;
		tau = 1.0;
		eta = 1.0; 

		// Hyperparameters
		s = 0.1;
		S = 0.1;
		a = 0.1;
		b = 0.1;
		u = 1.0;
		U = 0.1;
		w = 0.1;
		W = 0.1;

		// Learning flag
		learn_a = true;
		learn_m = true;
		// Iteration
		l = 0;
		burnin = 5000;
		thin = 100;
		N = 1000;
		iter = thin * N;
		// plot
		plot = 1000;
		mcmc_done = false;
		cnt = 0;
		plot_ready = false;
		// step ʱȭ 
		step = 0;
		y_max = 0;

		// 迭 ʱȭѴ. 
		Y = (double*)malloc(n*sizeof(double));
		mu = (double*)malloc(n*sizeof(double));
		V = (double*)malloc(n*sizeof(double));
		q = (double*)malloc((n + 1)*sizeof(double));
		n_j = (int*)malloc(n*sizeof(int));
		z = (int*)malloc(n*sizeof(int));
		index = (int*)malloc(n*sizeof(int));
		rindex = (int*)malloc(n*sizeof(int));
		ll = (double*)malloc((burnin + iter)*sizeof(double));
		p = (double*)malloc(K*sizeof(double));

		save_alpha = (double*)malloc(N*sizeof(double));
		save_m = (double*)malloc(N*sizeof(double));
		save_tau = (double*)malloc(N*sizeof(double));
		density_x = (double*)malloc(plot*sizeof(double));
		density_y = (double*)malloc(plot*sizeof(double));
		density_x2 = (double*)malloc(plot*sizeof(double));
		density_y2 = (double*)malloc(plot*sizeof(double));

		acf_alpha = (double*)malloc(30 * sizeof(double));
		acf_m = (double*)malloc(30 * sizeof(double));
		acf_tau = (double*)malloc(30 * sizeof(double));
		acf_x = (double*)malloc(30 * sizeof(double));

		trace_x = (double*)malloc(N*sizeof(double));
		trace_alpha = (double*)malloc(N*sizeof(double));
		trace_m = (double*)malloc(N*sizeof(double));
		trace_tau = (double*)malloc(N*sizeof(double));

		// Histogram
		nbin = 30;
		hist_x = (double*)malloc((3 * nbin + 1)*sizeof(double));
		hist_y = (double*)malloc((3 * nbin + 1)*sizeof(double));
		hist_y2 = (double*)malloc((3 * nbin + 1)*sizeof(double));

		// random number seed
		const gsl_rng_type *T;
		gsl_rng_env_setup();
		T = gsl_rng_default;
		r = gsl_rng_alloc(T);
		gsl_rng_set(r, (unsigned long)time(NULL));
	} // void init():  ʱȭ Լ̴. 


public:
	// Flag
	bool data_loaded;

	// Hyper-parameter
	double u;
	double U;
	double w;
	double W;
	double s;
	double S;
	double a;
	double b;

	// Random variable
	double m;
	double alpha;
	double tau;
	double eta;

	// Parameter
	int n;		//   
	int K;		// Ŭ  
	int N;
	int l;
	int iter;   // Iteration 
	int burnin;
	int thin;
	
	// Sample 
	int nr_total;
	double Ytotal[MAX_Y];
	double *Y;		// Observation 
	double *mu;
	double *V;
	double *q;
	double y_max;

	// Plot
	int plot;

	// Indexing paramter
	int *n_j;
	int *z; // Ŭ ! 
	int *index;
	int *rindex;
	// Likelihood
	double *ll;
	double *p;

	// Learning flag
	bool learn_a;
	bool learn_m;
	bool dft;	// Default param   


	// gsl variables
	gsl_rng *r;

	// Results
	double *save_alpha;
	double *save_m;
	double *save_tau; 
	double *density_x;
	double *density_y;
	double *density_x2;
	double *density_y2;
	double *acf_alpha;
	double *acf_m;
	double *acf_tau; 
	double *acf_x;
	double *trace_x;
	double *trace_alpha;
	double *trace_m;
	double *trace_tau;
	bool mcmc_done;

	// Histogram
	int nbin;
	double *hist_x;
	double *hist_y;
	double *hist_y2;

	// Plot flag
	bool plot_ready;

	// Temps
	double min, max, interval;
	int cnt;

	// Step (0: init, 1: MCMC, 2: clean)
	int step;
};
