#pragma once

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_sf.h>

void rG(gsl_rng *r, double *mu, double *v, double m, double s, double S, double tau, double y);
void compute_q(double *q, int *n_j, double alpha, double m, double s, double S, double tau, double y, int length, double *mu, double *V, int *rindex);
int rbernoulli(gsl_rng *r, double prob);
int rmultinom(gsl_rng *r, double *prob, int K, bool normalized);
void swap(int *index, int *rindex, int i, int j);
double rm(gsl_rng *r, double tau, double u, double U, int K, double *mu, double *V, int *rindex);
double rtau(gsl_rng *r, double m, double w, double W, int K, double *mu, double *V, int *rindex);
double ralpha(gsl_rng *r, double eta, int n, int K, double a, double b);
int compare(const void* pa, const void* pb);
void acf(double *acf_a, double *a, int N);

double rand_range(double fr, double to);
void linespace(double* arr, double fr, double to, int nr_data);
