#include "stdafx.h"
#include "BayesianDensity.h"
#include "BayesianDensityDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

void CBayesianDensityDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮԴϴ.

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC dc(this);			// ׸⸦  ̽ ؽƮ
		CRect rect1, rect2;			// Ŭ̾Ʈ  ũ
		CDC memDC1, memDC2;			// CDC for STAGE
		CBitmap imgBit1, imgBit2;
		CBrush brush_black(COLOR_D_BLACK);
		CBrush brush_lgreen(COLOR_L_GREEN);
		CBrush brush_lred(COLOR_L_RED);
		CBrush brush_lblue(COLOR_L_BLUE);
		CBrush brush_lpurple(COLOR_L_PURPLE);
		CBrush brush_white(COLOR_WHITE);
		CBrush brush_gray(COLOR_L_BLACK);

		CBrush brush_stage(COLOR_DEFINE(0.8, 0.99, 0.9));
		CBrush brush_bg1(COLOR_DEFINE(0.99, 0.99, 0.99));
		CBrush brush_bg2(COLOR_DEFINE(0.99, 0.99, 0.99));

		CPen pen_lblue(PS_SOLID, 1, COLOR_L_BLUE);
		CPen pen_dred(PS_SOLID, 2, COLOR_D_RED);
		CPen pen_black(PS_SOLID, 2, COLOR_DEFINE(0, 0, 0));


		int plot_radius = 5;

		// **************************** Stage 1 **************************** 
		GetClientRect(&rect1);	// Ŭ̾Ʈ  ũ⸦ 	
		memDC1.CreateCompatibleDC(&dc);
		imgBit1.CreateCompatibleBitmap(&dc, rect1.Width(), rect1.Height());
		memDC1.SelectObject(&imgBit1);
		// ⺻ stage1  ĥѴ. 
		memDC1.SelectObject(brush_bg1);
		memDC1.Rectangle(stage1_left, stage1_top, stage1_right, stage1_btm);
		// ȸ 簢 ׸. ( ǹѴ.)
		DrawSquare1(&memDC1, &brush_stage, 0, 1000, 0, 1000);
		//    
		for (int i = 1; i < m_nDrawCnt1; i++)
			DrawLine1(&memDC1, &pen_black, m_pDraw1[i - 1], m_pDraw1[i]);
		for (int i = 0; i<m_nDrawCnt1; i++)
			DrawCircle1(&memDC1, &brush_lred, m_pDraw1[i], plot_radius);

		// 1. Density ׸. ͸ ҷ Ŀ ׸. 
		if (param->plot_ready)
		{
			for (int i = 1; i < param->plot; i++)
			{
				CPoint fr, to;
				fr.x = param->density_x2[i - 1];
				fr.y = param->density_y2[i - 1];
				to.x = param->density_x2[i];
				to.y = param->density_y2[i];
				DrawLine1(&memDC1, &pen_black, fr, to);
			}
		}
		// 2. Histogram ׸. 
		if (param->data_loaded)
		{
			for (int i = 1; i < 3 * param->nbin + 1; i++)
			{
				CPoint fr, to;
				fr.x = param->hist_x[i - 1];
				fr.y = param->hist_y2[i - 1];
				to.x = param->hist_x[i];
				to.y = param->hist_y2[i];
				DrawLine1(&memDC1, &pen_dred, fr, to);
			}
		}

		// ۸
		dc.BitBlt(stage1_left, stage1_top, stage1_w, stage1_h, &memDC1, 0, 0, SRCCOPY);
		//޸ ȯ
		memDC1.DeleteDC();
		imgBit1.DeleteObject();


		// **************************** Stage 2 **************************** 
		GetClientRect(&rect2);	// Ŭ̾Ʈ  ũ⸦ 	
		memDC2.CreateCompatibleDC(&dc);
		imgBit2.CreateCompatibleBitmap(&dc, rect2.Width(), rect2.Height());
		memDC2.SelectObject(&imgBit2);
		// ⺻ stage2  ĥѴ. 
		memDC2.SelectObject(brush_bg2);
		memDC2.Rectangle(0, stage2_top, stage2_right, stage2_btm);
		// ȸ 簢 ׸. ( ǹѴ.)
		DrawSquare2(&memDC2, &brush_stage, 0, 1000, 0, 1000);
		//    
		for (int i = 1; i < m_nDrawCnt2; i++)
			DrawLine2(&memDC2, &pen_black, m_pDraw2[i - 1], m_pDraw2[i]);
		for (int i = 0; i<m_nDrawCnt2; i++)
			DrawCircle2(&memDC2, &brush_lred, m_pDraw2[i], plot_radius);
		// Plot2
		for (int i = 1; i < nr_plot2; i++)
			DrawLine2(&memDC2, &pen_black, data2plot2[i - 1], data2plot2[i]);
		for (int i = 0; i<nr_plot2; i++)
			DrawCircle2(&memDC2, &brush_white, data2plot2[i], plot_radius);

		// acf ׸. 
		if (param->mcmc_done)
		{
			for (int i = 0; i < 30; i++)
			{
				CPoint fr, to;
				fr.x = param->acf_x[i];
				to.x = param->acf_x[i];
				if (acf_alpha){
					fr.y = 0;
					to.y = param->acf_alpha[i];
				}
				else if (acf_mu){
					fr.y = 0;
					to.y = param->acf_m[i];
				}
				else if (acf_tau){
					fr.y = 0;
					to.y = param->acf_tau[i];
				}
				DrawLine2(&memDC2, &pen_black, fr, to);
			}
			for (int i = 0; i < 30; i++)
			{
				CPoint to;
				to.x = param->acf_x[i];
				if (acf_alpha){
					to.y = param->acf_alpha[i];
				}
				else if (acf_mu){
					to.y = param->acf_m[i];
				}
				else if (acf_tau){
					to.y = param->acf_tau[i];
				}
				DrawCircle2(&memDC2, &brush_lred, to, 10);
			}

			for (int i = 1; i < param->N; i++)
			{
				CPoint fr, to;
				fr.x = param->trace_x[i-1];
				to.x = param->trace_x[i];
				if (acf_alpha){
					fr.y = param->trace_alpha[i - 1];
					to.y = param->trace_alpha[i];
				}
				else if (acf_mu){
					fr.y = param->trace_m[i - 1];
					to.y = param->trace_m[i];
				}
				else if (acf_tau){
					fr.y = param->trace_tau[i - 1];
					to.y = param->trace_tau[i];
				}
				// printf("[%d/%d] x: %.1f \n", i, param->N, fr.x);
				DrawLine2(&memDC2, &pen_lblue, fr, to);
			}
		}

		// ۸
		dc.BitBlt(stage2_left, stage2_top, stage2_w, stage2_h, &memDC2, 0, 0, SRCCOPY);
		//޸ ȯ
		memDC2.DeleteDC();
		imgBit2.DeleteObject();


		// ⺻ stage2  ĥѴ. 
		// memDC.SelectObject(brush_lblue);
		// memDC.Rectangle(stage2_left, stage2_top, stage2_right, stage2_btm);

		CDialogEx::OnPaint();
	}
}

