#include "stdafx.h"
#include "BayesianDensity.h"
#include "BayesianDensityDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


void CBayesianDensityDlg::MyWorkFunc()
{
	if (is_running)
	{
		switch (param->step)
		{
		case 0:{ // ʱȭ ܰ
			// 1. ־  ŭ Ytotal迭 Y 迭 о´. ̰ 츮 observation̴. 
			printf("Initialization of MCMC \n");
			for (int i = 0; i < param->n; i++)
			{
				param->Y[i] = param->Ytotal[i];
			}

			// 2.  Ķ óϱ 
			param->m = 0.0;
			for (int i = 0; i < param->n; i++)
			{
				param->m += param->Y[i];
			}
			param->m /= param->n;
			double var = 0.0;
			for (int i = 0; i < param->n; i++)
			{
				var += pow(param->Y[i] - param->m, 2.0);
			}
			var /= param->n;
			if (param->dft) // Default parameter  쿡 u U ٲ۴. 
			{
				// 1. u empirical mean Ѵ. 
				param->u = param->m;
				// 2. U empirical var Ѵ. 
				// param->U = var;
				// 3. tau
				param->tau = param->n / 10.0;
			}
			else
			{
				//  쿡 manually ־  ʱȭ Ѵ. 
				this->PostMessage(UM_UPDATE_T);
				CString str;
				double u, U, w, W, s, S, a, b, m, tau;
				GetDlgItem(IDC_EDIT_INPUT_u)->GetWindowText(str);
				u = _wtof(str);
				GetDlgItem(IDC_EDIT_INPUT_uc)->GetWindowText(str);
				U = _wtof(str);
				GetDlgItem(IDC_EDIT_INPUT_w)->GetWindowText(str);
				w = _wtof(str);
				GetDlgItem(IDC_EDIT_INPUT_wc)->GetWindowText(str);
				W = _wtof(str);
				GetDlgItem(IDC_EDIT_INPUT_s)->GetWindowText(str);
				s = _wtof(str);
				GetDlgItem(IDC_EDIT_INPUT_sc)->GetWindowText(str);
				S = _wtof(str);
				GetDlgItem(IDC_EDIT_INPUT_a)->GetWindowText(str);
				a = _wtof(str);
				GetDlgItem(IDC_EDIT_INPUT_b)->GetWindowText(str);
				b = _wtof(str);
				GetDlgItem(IDC_EDIT_INPUT_m)->GetWindowText(str);
				m = _wtof(str);
				GetDlgItem(IDC_EDIT_INPUT_tau)->GetWindowText(str);
				tau = _wtof(str);
				param->u = u;
				param->U = U;
				param->w = w;
				param->W = W;
				param->s = s;
				param->S = S;
				param->a = a;
				param->b = b;
				param->m = m;
				param->tau = tau;
			}

			// 3.   iteration  о´. (N, thin, burnin)
			CString str;
			int N, thin, burnin;
			GetDlgItem(IDC_EDIT_INPUT_N)->GetWindowText(str);
			N = _wtoi(str);
			GetDlgItem(IDC_EDIT_INPUT_thin)->GetWindowText(str);
			thin = _wtoi(str);
			GetDlgItem(IDC_EDIT_INPUT_burnin)->GetWindowText(str);
			burnin = _wtoi(str);
			if (N == 0) param->N = 1000; else param->N = N;
			if (thin == 0) param->thin = 10; else param->thin = thin;
			if (burnin == 0) param->burnin = 5000; else param->burnin = burnin;
			param->iter = param->thin * param->N;

			//   缭 迭 ٽ ҴѴ. 
			free(param->save_alpha);
			free(param->save_m);
			free(param->save_tau);
			free(param->trace_x);
			free(param->trace_alpha);
			free(param->trace_m);
			free(param->trace_tau);
			param->save_alpha = (double*)malloc(param->N*sizeof(double));
			param->save_m = (double*)malloc(param->N*sizeof(double));
			param->save_tau = (double*)malloc(param->N*sizeof(double));
			param->trace_x = (double*)malloc(param->N*sizeof(double));
			param->trace_alpha = (double*)malloc(param->N*sizeof(double));
			param->trace_m = (double*)malloc(param->N*sizeof(double));
			param->trace_tau = (double*)malloc(param->N*sizeof(double));


			// 4.  ˰  Console1 . 
			printf("4. Print current status to Console 1 \n");
			str.Format(_T("burnin: %d, thin: %d, N: %d, Total Iteration: %d \r\n")
				, param->burnin, param->thin, param->N, param->iter + param->burnin);
			printf_edit1(str);
			if (param->dft)
				str.Format(_T("Using Default Parameters \r\n"));
			else
				str.Format(_T("Using Manual Parameters \r\n"));
			printf_edit1(str);
			str.Format(_T(" u: %.2f, U: %.2f, w: %.2f, W: %.2f \r\n s: %.2f, S: %.2f, a: %.2f, b: %.2f \r\n")
				, param->u, param->U, param->w, param->W, param->s, param->S, param->a, param->b);
			printf_edit1(str);
			str.Format(_T("alpah: %.2f m: %.2f, tau: %.2f \r\n")
				, param->alpha, param->m, param->tau);
			printf_edit1(str);
			if (param->learn_a && param->learn_m)
				str.Format(_T("Sample Both Alpha, m, and tau \r\n"));
			else if (param->learn_a)
				str.Format(_T("Sample Alpha only \r\n"));
			else if (param->learn_m)
				str.Format(_T("Sample m, tau only \r\n"));
			else
				str.Format(_T("Use prefixed Alpha, m, and tau \r\n"));
			printf_edit1(str);

			// 5.   ʱȭ 
			for (int i = 0; i < param->n; i++)
			{
				param->n_j[i] = 0;
				param->index[i] = i;
				param->rindex[i] = i;
			}

			// 6. Y Ѵ. 
			printf("6. Sorting Y \n");
			qsort(param->Y, param->n, sizeof(double), compare);
			
			// 7.  Ϳ mu, V ҴѴ. 
			printf("7. Allocation mu and V to each data \n");
			for (int k = 0; k < param->K; k++)
			{
				param->mu[k] = param->Y[param->n*k / param->K];
				param->V[k] = var;
				param->p[k] = 1.0 / (double)(param->K);
			}

			// 8.  Ͱ  class  ʱȭѴ. 
			printf("8. Initialize class \n");
			for (int i = 0; i < param->n; i++)
			{
				param->z[i] = rmultinom(param->r, param->p, param->K, 1);
				param->n_j[param->z[i]]++;
			}

			// 9. Density ʱȭѴ. 
			param->min = param->Y[0] - (param->Y[param->n - 1] - param->Y[0]) / 100.0;
			param->max = param->Y[param->n - 1] + (param->Y[param->n - 1] - param->Y[0]) / 100.0;
			param->interval = (param->max - param->min) / ((double)(param->plot) - 1.0);
			for (int j = 0; j < param->plot; j++)
			{
				param->density_x[j] = param->min + param->interval * (double)j;
				param->density_y[j] = 0.0;
			}
			int ind, cnt = 0;

			// 10. Histogram ʱȭѴ. 
			param->hist_x[0] = param->min; 
			param->hist_x[1] = param->min;
			for (int j = 1; j<param->nbin; j++)
			{
				param->hist_x[3 * j - 1] = param->min + (double)j * (param->max - param->min) / (double)(param->nbin);
				param->hist_x[3 * j] = param->min + (double)j * (param->max - param->min) / (double)(param->nbin);
				param->hist_x[3 * j + 1] = param->min + (double)j * (param->max - param->min) / (double)(param->nbin);
			}
			param->hist_x[3 * param->nbin - 1] = param->max; 
			param->hist_x[3 * param->nbin] = param->max;
			ind = 0; cnt = 0;
			for (int j = 0; j<param->nbin + 1; j++)	param->hist_y[3 * j] = 0.0;
			for (int i = 0; i<param->n; i++)
			{
				// ׷ īƮ  
				int next_ind = ind + 3;
				if (param->hist_x[ind] <= param->Y[i] && param->Y[i] < param->hist_x[next_ind]) cnt++;
				//  ׷  update 
				double hist_x_val = param->hist_x[next_ind];
				double y_val = param->Y[i];
				if (hist_x_val < y_val)
				{
					param->hist_y[ind + 1] = (double)cnt * (double)(param->nbin) / (double)(param->n) / (param->max - param->min);
					param->hist_y[ind + 2] = (double)cnt * (double)(param->nbin) / (double)(param->n) / (param->max - param->min);
					ind = ind + 3;
					cnt = 0;
				}
			}
			param->hist_y[ind + 1] = (double)cnt * (double)(param->nbin) / (double)(param->n) / (param->max - param->min);
			param->hist_y[ind + 2] = (double)cnt * (double)(param->nbin) / (double)(param->n) / (param->max - param->min);
			cnt = 0;

			// Density ʱȭ 
			for (int j = 0; j<param->plot; j++)		
				param->density_x2[j] = (param->density_x[j] - param->min) / (param->max - param->min) * 1000.0;
			for (int j = 0; j<3 * param->nbin + 1; j++)	
				param->hist_x[j] = (param->hist_x[j] - param->min) / (param->max - param->min) * 1000.0;

			// 11. step ѱ.  MCMC Ѵ. 
			param->step = 1;
			param->l = 0;
			Invalidate();
		}break;

		case 1:{ // MCMC ϴ ܰ
			// 1. update m, tau, alpha, eta
			if (param->learn_a && param->learn_m)
			{
				for (int i = 0; i < 50; i++)
				{
					param->tau = rtau(param->r, param->m, param->w, param->W, param->K, param->mu, param->V, param->rindex);
					param->m = rm(param->r, param->tau, param->u, param->U, param->K, param->mu, param->V, param->rindex);
					param->eta = log(gsl_ran_beta(param->r, param->alpha + 1.0, (double)(param->n)));
					param->alpha = ralpha(param->r, param->eta, param->n, param->K, param->a, param->b);
				}
			}
			else if (param->learn_a)
			{
				for (int i = 0; i < 50; i++)
				{
					param->eta = log(gsl_ran_beta(param->r, param->alpha + 1.0, (double)(param->n)));
					param->alpha = ralpha(param->r, param->eta, param->n, param->K, param->a, param->b);
				}
			}
			else if (param->learn_m)
			{
				for (int i = 0; i < 50; i++)
				{
					param->tau = rtau(param->r, param->m, param->w, param->W, param->K, param->mu, param->V, param->rindex);
					param->m = rm(param->r, param->tau, param->u, param->U, param->K, param->mu, param->V, param->rindex);
				}
			}

			// 2. update pi
			for (int i = 0; i < param->n; i++)
			{
				int zi = param->z[i];
				param->n_j[zi]--;
				if (param->n_j[zi] == 0){
					if (zi != param->rindex[param->K - 1])	swap(param->index, param->rindex, zi, param->rindex[param->K - 1]);
					param->K--;
				}
				compute_q(param->q, param->n_j, param->alpha, param->m
					, param->s, param->S, param->tau, param->Y[i], param->K
					, param->mu, param->V, param->rindex);
				zi = rmultinom(param->r, param->q, param->K + 1, 0);
				int ind = param->rindex[zi];
				if (zi == param->K)
				{
					rG(param->r, &(param->mu[ind]), &(param->V[ind]), param->m
						, param->s, param->S, param->tau, param->Y[i]);
					param->z[i] = ind;
					param->n_j[ind] = 1;
					param->K++;
				}
				else
				{
					param->z[i] = ind;
					param->n_j[ind]++;
				}
			}

			// 3. 100  ѹ Log Likelihood  
			if (param->l % 100 == 0)
			{
				param->ll[param->l] = 0.0;
				for (int i = 0; i < param->n; i++)
				{
					param->ll[param->l] += log(gsl_ran_gaussian_pdf(param->Y[i]
						- param->mu[param->z[i]], sqrt(param->V[param->z[i]])));
				}
				param->ll[param->l] /= (double)(param->n);
				CString str; str.Format(_T("iter: %d log_lik: %.3f \r\n"), param->l, param->ll[param->l]);
				printf_edit2(str);
			}

			// 4. ø Ƽ  
			if ((param->l >= param->burnin) && ((param->l - param->burnin) % param->thin == 0))
			{
				double M = (1.0 + param->tau) * param->S / param->s;
				double an = 1.0 / (param->alpha + (double)param->n);
				for (int j = 0; j < param->plot; j++)
				{
					double density = param->alpha * an
						* gsl_ran_tdist_pdf((param->density_x[j] - param->m) / sqrt(M), param->s);
					for (int k = 0; k < param->K; k++)
					{
						int ind = param->rindex[k];
						density += an * (double)(param->n_j[ind])
							* gsl_ran_gaussian_pdf(param->density_x[j] - param->mu[ind]
							, sqrt(param->V[ind]));
					}
					param->density_y[j] += density / (double)(param->N);
				}
				// printf("param->cnt: %d / %d \n", param->cnt, param->N);
				if (param->cnt >= param->N) param->cnt = param->N-1;
				param->save_alpha[param->cnt] = param->alpha;
				param->save_m[param->cnt] = param->m;
				param->save_tau[param->cnt] = param->tau;
				param->cnt++;
			}
			if ((param->l >= param->burnin) && ((param->l - param->burnin) % 1000 == 0))
			{
				param->y_max = 0.0;
				for (int j = 0; j<param->plot; j++)
				{
					double density = param->density_y[j] * (double)(param->N) / (double)(param->cnt);
					if (density > param->y_max){
						param->y_max = density;
					}
				}
				param->y_max *= 1.01;
				for (int j = 0; j<param->plot; j++)	
					param->density_y2[j] = (param->density_y[j] * (double)(param->N) / (double)(param->cnt)) / param->y_max * 1000.0;
				for (int j = 0; j<3 * param->nbin + 1; j++)	
					param->hist_y2[j] = param->hist_y[j] / param->y_max * 1000.0;

				// ⿡ density density_x2, density_y2. hist hist_x,hist_y2 ׸
				param->plot_ready = true;
				Invalidate();
			}
			
			// 5. ׸ Update Ų. 
			if ((param->l >= param->burnin) && (param->l % 2000 == 0))
				Invalidate();

			// 6.  iteration ϰ  ܰ Ѿ.
			if ((param->l)++ >= param->burnin + param->iter)
			{
				Invalidate();
				param->step = 2;
			}
		}
			break;
		case 2:{// MCMC  ̴.  ϰ, ޸𸮸 ȯ. 
			printf("MCMC is done! \n");
			// Last plot
			param->y_max = 0.0;
			for (int j = 0; j<param->plot; j++){
				double density = param->density_y[j] * param->N / param->cnt;
				if (density > param->y_max){
					param->y_max = density;
				}
			}
			param->y_max *= 1.01;
			for (int j = 0; j<param->plot; j++)	
				param->density_y2[j] = (param->density_y[j] * param->N / param->cnt) / param->y_max * 1000.0;
			for (int j = 0; j<3 * param->nbin + 1; j++)	
				param->hist_y[j] = param->hist_y[j] / param->y_max * 1000.0;

			// 1. ACF Ѵ. 
			printf("1. Compute ACF. \n");
			acf(param->acf_alpha, param->save_alpha, param->N);
			acf(param->acf_m, param->save_m, param->N);
			acf(param->acf_tau, param->save_tau, param->N);
			for (int j = 0; j<30; j++)	
			{
				param->acf_x[j] = (j + 1.0) * 33.0;
				param->acf_alpha[j] *= 400, 0;
				param->acf_m[j] *= 400, 0;
				param->acf_tau[j] *= 400, 0;
			}

			param->mcmc_done = true;
			CString str;
			str.Format(_T("MCMC Done! \r\n"));
			printf_edit1(str);

			// 2. Trace Ѵ. 
			printf("2. Compute trace. \n");
			for (int i = 0; i < param->N; i++)	
				param->trace_x[i] = (double)i / (double)(param->N) * 1000.0;

			double min_a, min_m, min_t;
			min_a = min_m = min_t = 10000000.0;
			double max_a, max_m, max_t;
			max_a = max_m = max_t = -10000000.0;

			for (int i = 0; i<param->N; i++){
				if (min_a > param->save_alpha[i])	min_a = param->save_alpha[i];
				if (min_m > param->save_m[i])		min_m = param->save_m[i];
				if (min_t > param->save_tau[i])		min_t = param->save_tau[i];

				if (max_a < param->save_alpha[i])	max_a = param->save_alpha[i];
				if (max_m < param->save_m[i])		max_m = param->save_m[i];
				if (max_t < param->save_tau[i])		max_t = param->save_tau[i];
			}

			for (int i = 0; i<param->N; i++){
				param->trace_alpha[i]  = (param->save_alpha[i] - min_a) / (max_a - min_a) * 400.0 + 600.0;
				param->trace_m[i]      = (param->save_m[i] - min_m) / (max_m - min_m) * 400.0 + 600.0;
				param->trace_tau[i]    = (param->save_tau[i] - min_t) / (max_t - min_t) * 400.0 + 600.0;
			}

			// 3. Ϸ Ѵ. 
			//*
			printf("3. Saving Results. \n");
			CString filePath1 = m_strFolderPath + _T("\\alpha.txt");
			CString filePath2 = m_strFolderPath + _T("\\m.txt");
			CString filePath3 = m_strFolderPath + _T("\\tau.txt");
			CString filePath4 = m_strFolderPath + _T("\\density.txt");
			CString filePath5 = m_strFolderPath + _T("\\loglike.txt");

			CStdioFile ftxt1, ftxt2, ftxt3, ftxt4, ftxt5;
			CString temp_str;
			// printf("filePath1: %S \n", filePath1);
			
			ftxt1.Open(filePath1, CFile::modeCreate | CFile::modeReadWrite);
			ftxt2.Open(filePath2, CFile::modeCreate | CFile::modeReadWrite);
			ftxt3.Open(filePath3, CFile::modeCreate | CFile::modeReadWrite);
			ftxt4.Open(filePath4, CFile::modeCreate | CFile::modeReadWrite);
			ftxt5.Open(filePath5, CFile::modeCreate | CFile::modeReadWrite);
			
			for (int i = 0; i < param->N; i++){
				temp_str.Format(_T("%lf\n"), param->save_alpha[i]); ftxt1.WriteString(temp_str);
				temp_str.Format(_T("%lf\n"), param->save_m[i]); ftxt2.WriteString(temp_str);
				temp_str.Format(_T("%lf\n"), param->save_tau[i]); ftxt3.WriteString(temp_str);
			}
			for (int j = 0; j < param->plot; j++){
				temp_str.Format(_T("%lf, %lf \n"), param->density_x[j], param->density_y[j]); ftxt4.WriteString(temp_str);
			}
			for (int i = 0; i < (param->burnin + param->iter) / 100; i++){
				temp_str.Format(_T("%.4f \n"), param->ll[100*i]); ftxt5.WriteString(temp_str);
			}
			ftxt1.Close();
			ftxt2.Close();
			ftxt3.Close();
			ftxt4.Close();
			ftxt5.Close();


			/*
			FILE *outfile1, *outfile2, *outfile3, *outfile4, *outfile5, *outfile6;
			outfile1 = fopen("C:\\Users\\human\\Desktop\\BayesianDensityEstimation - Submit\\BayesianDensity\\BayesianDensity\\alpha.txt", "w");
			outfile2 = fopen("C:\\Users\\human\\Desktop\\BayesianDensityEstimation - Submit\\BayesianDensity\\BayesianDensity\\m.txt", "w");
			outfile3 = fopen("C:\\Users\\human\\Desktop\\BayesianDensityEstimation - Submit\\BayesianDensity\\BayesianDensity\\tau.txt", "w");
			outfile4 = fopen("C:\\Users\\human\\Desktop\\BayesianDensityEstimation - Submit\\BayesianDensity\\BayesianDensity\\x.txt", "w");
			outfile5 = fopen("C:\\Users\\human\\Desktop\\BayesianDensityEstimation - Submit\\BayesianDensity\\BayesianDensity\\y.txt", "w");
			outfile6 = fopen("C:\\Users\\human\\Desktop\\BayesianDensityEstimation - Submit\\BayesianDensity\\BayesianDensity\\loglike.txt", "w");
			for (int i = 0; i < param->N; i++){
				fprintf(outfile1, "%lf\n", param->save_alpha[i]);
				fprintf(outfile2, "%lf\n", param->save_m[i]);
				fprintf(outfile3, "%lf\n", param->save_tau[i]);
			}
			for (int j = 0; j < param->plot; j++){
				fprintf(outfile4, "%lf\n", param->density_x[j]);
				fprintf(outfile5, "%lf\n", param->density_y[j]);
			}
			for (int i = 0; i < (param->burnin + param->iter) / 100; i++){
				fprintf(outfile6, "%lf\n", param->ll[i]);
			}
			fclose(outfile1);
			fclose(outfile2);
			fclose(outfile3);
			fclose(outfile4);
			fclose(outfile5);
			fclose(outfile6);
			//*/

			// 4. Free things 
			printf("4. Free things \n");
			free(param->Y);
			free(param->mu);
			free(param->V);
			free(param->q);
			free(param->n_j);
			free(param->z);
			free(param->p);
			free(param->ll);
			free(param->save_alpha);
			free(param->save_m);
			free(param->save_tau);

			/*
			free(param->density_x);
			free(param->density_y);
			free(param->density_x2);
			free(param->density_y2);
			free(param->acf_x);
			free(param->acf_alpha);
			free(param->acf_m);
			free(param->acf_tau);

			free(param->trace_x);
			free(param->trace_alpha);
			free(param->trace_m);
			free(param->trace_tau);

			free(param->hist_x);
			free(param->hist_y);
			free(param->hist_y2);
			//*/

			gsl_rng_free(param->r);

			// 4. Ḧ Ų. 
			OnBnClickedBtnStart();
		}
			break;
		}
	} // if (is_running) 

	return;
}

UINT CBayesianDensityDlg::MyThreadFunc(LPVOID pThreadParam)
{
	// Ѿ  ĶͰ void   ̹Ƿ THREADPARAM  ͷ ݵ ĳؾ Ѵ.
	THREADPARAM *pParam = (THREADPARAM *)pThreadParam;

	CBayesianDensityDlg *pMydlg = (CBayesianDensityDlg *)pParam->pWnd; // ̰  ĳ ؾ Ѵ.
	BOOL *pDo = pParam->pDo; // ̰  Ÿ̹Ƿ ĳ ʿ .

	//  ʿ ͸     pParam (?) ؾ ޸  .
	delete pParam;

	// *pDo TRUE  尡 ۾ Ѵ.
	while (*pDo) // ⿡ *pDoſ pMydlg->m_bDo ص ȴ.    Ƿ   
	{
		pMydlg->MyWorkFunc(); // ϴ ۾ Ѵ.
		// Ÿ ϴ ۾ ̰  ȴ.
		Sleep(0);
	}

	return 0; // ݵ  ؾ Ѵ. 0  ϴ   ̴.
}

void CBayesianDensityDlg::StartThread()
{
	printf("[StartThread] \n");
	// Լ Ķͷ  ü  Ѵ.
	THREADPARAM *pThreadParam = new THREADPARAM; 
	pThreadParam->pWnd = this; // ⼭ this CMydlg ü ǹѴ.
	pThreadParam->pDo = &m_bDo; // ÷ ͸ ´.

	// AfxBeginThread Լ 尡 Ǿ ȴ.
	m_pThread = AfxBeginThread(MyThreadFunc, pThreadParam);
}

void CBayesianDensityDlg::StopThread()
{
	printf("[StopThread] \n");
	m_bDo = FALSE; //   Ű  FALSE ԷѴ.

	Sleep(100); // ̰ ſ ߿ϴ. ̰   尡 ۵  ȵ  ִ. 忡 üũ  شٰ ϸ ȴ.

	//  ÷  Է Ʒ Լ 尡   ٷ ش.
	if (::WaitForSingleObject(m_pThread->m_hThread, INFINITE)) // INFINITE  ٷ شٴ ǹ̴.
	{
		// 尡    ´.
		m_pThread = NULL; //   .
		//    ͵ ⿡  ȴ.
	}
}

