#include "stdafx.h"
#include "BayesianDensity.h"
#include "BayesianDensityDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// Start / Stop ư ó 
void CBayesianDensityDlg::OnBnClickedBtnStart()
{
	printf("[OnBnClickedBtnStart] \n");
	if (is_running)
	{
		// ߿ Ų. 
		m_btnStartStop.SetWindowTextW(_T("Start"));
		m_strEditIsRunning.Format(_T("Not running"));
		//UpdateData(FALSE);
		this->PostMessage(UM_UPDATE);
		printf("Stop running \n");
		is_running = false;
	}
	else if (param->mcmc_done)
	{
		//  mcmc ѹ  ڿ resetؾѴ. 
		AfxMessageBox(_T("Reset First!"));
	}
	else
	{
		if (!param->data_loaded)
		{
			//  ͸ load  ¿ ˰ Ϸ Ѵٸ ´. 
			AfxMessageBox(_T("Load Data First!"));
		}
		else
		{
			// Ͱ load Ǿִٸ thread  Ų. 
			m_btnStartStop.SetWindowTextW(_T("Stop"));
			m_strEditIsRunning.Format(_T("Running"));
			this->PostMessage(UM_UPDATE);
			printf("Start running \n");

			// 带 Ų. 
			is_running = true;

			// Console 1 . 
			CString str;
			str.Format(_T("Starting MCMC for Bayesian Density Estimation \r\n"));
			printf_edit1(str);
		}
	}
	focus_last_line();
	Invalidate();
}

//  ư ó 
void CBayesianDensityDlg::OnBnClickedBtnReset()
{
	printf("[OnBnClickedBtnReset] \n");
	param->init();
	CheckDlgButton(IDC_CHECK1, param->dft);
	CheckDlgButton(IDC_CHECK2, param->learn_a);
	CheckDlgButton(IDC_CHECK3, param->learn_m);
	GetDlgItem(IDC_EDIT_INPUT_u)->SendMessage(EM_SETREADONLY, 1, 0);
	GetDlgItem(IDC_EDIT_INPUT_uc)->SendMessage(EM_SETREADONLY, 1, 0);
	GetDlgItem(IDC_EDIT_INPUT_w)->SendMessage(EM_SETREADONLY, 1, 0);
	GetDlgItem(IDC_EDIT_INPUT_wc)->SendMessage(EM_SETREADONLY, 1, 0);
	GetDlgItem(IDC_EDIT_INPUT_s)->SendMessage(EM_SETREADONLY, 1, 0);
	GetDlgItem(IDC_EDIT_INPUT_sc)->SendMessage(EM_SETREADONLY, 1, 0);
	GetDlgItem(IDC_EDIT_INPUT_a)->SendMessage(EM_SETREADONLY, 1, 0);
	GetDlgItem(IDC_EDIT_INPUT_b)->SendMessage(EM_SETREADONLY, 1, 0);

	// ó Note running ǥѴ.
	m_strEditIsRunning.Format(_T("Not running"));
	UpdateData(FALSE);
	focus_last_line();
}

//  ҷ 
void CBayesianDensityDlg::OnBnClickedBtnOpen()
{
	printf("[OnBnClickedBtnOpen] \n");
	CStdioFile ftxt;
	CFileException kEx;
	CFileDialog dlg(TRUE, _T("*.txt"), NULL, OFN_FILEMUSTEXIST, _T("TXT Files(*.txt)|*.txt|"), NULL);
	if (dlg.DoModal() == IDOK)
	{
		m_strPath = dlg.GetPathName();
		CString file_name = dlg.GetFileName();
		m_strFolderPath = m_strPath.Left(m_strPath.GetLength() - file_name.GetLength());
		//  . 
		if (!ftxt.Open(m_strPath, CFile::modeRead | CFile::typeText, &kEx))
		{
			return;
		}

		CString strLineBuffer;
		int i = 0;
		//for (i = 0; i < MAX_Y; i++)
		for (;;)
		{
			if (!ftxt.ReadString(strLineBuffer))
			{
				break;
			}
			double dNum = _wtof(strLineBuffer);
			param->Ytotal[i++] = dNum;
			// printf("[%d/%d] %.4f \n", i, MAX_Y, dNum);
		}
		printf("Total %d Data loaded. \n", i);
		param->nr_total = i;
		param->n = i;
		// ⼭ Ķ͸ ʱȭѴ.  
		param->init();
		CheckDlgButton(IDC_CHECK1, param->dft);
		CheckDlgButton(IDC_CHECK2, param->learn_a);
		CheckDlgButton(IDC_CHECK3, param->learn_m);

		CString str;
		str.Format(_T("Total %d Data Loaded. \r\n"),i);
		printf_edit1(str);

		// ͸  ҷ Ŀ density ʱȭѴ. 
		param->min = param->Y[0] - (param->Y[param->n - 1] - param->Y[0]) / 100.0;
		param->max = param->Y[param->n - 1] + (param->Y[param->n - 1] - param->Y[0]) / 100.0;
		param->interval = (param->max - param->min) / ((double)(param->plot) - 1.0);
		for (int j = 0; j<param->plot; j++)
		{
			param->density_x[j] = param->min + param->interval * (double)j;
			param->density_y[j] = 0.0;
		}

		// Flag Ѵ. 
		if (i > 0)
		{
			param->data_loaded = true;
			printf("param->data_loaded = true; \n");
		}
		ftxt.Close();

		UpdateData(FALSE);
		Invalidate(FALSE);
		focus_last_line();
	}
}

// Radio - alpha
void CBayesianDensityDlg::OnBnClickedRadio1()
{
	acf_alpha = true;
	acf_mu = false;
	acf_tau = false;
	Invalidate();
}

// Radio - mu
void CBayesianDensityDlg::OnBnClickedRadio2()
{
	acf_alpha = false;
	acf_mu = true;
	acf_tau = false;
	Invalidate();
}

// Radio - tau
void CBayesianDensityDlg::OnBnClickedRadio3()
{
	acf_alpha = false;
	acf_mu = false;
	acf_tau = true;
	Invalidate();
}

// Edit box1 ִ   Ѵ!! 
void CBayesianDensityDlg::OnBnClickedBtnSave()
{
	printf("[OnBnClickedBtnSave] \n");
	CString m_strPath; 
	CStdioFile file;
	// CFile file;
	CFileException ex;
	CFileDialog dlg(FALSE, _T("*.txt"), NULL, OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT, _T("TXT Files(*.txt)|*.txt|"), NULL);
	if( dlg.DoModal() == IDOK )
	{
		m_strPath = dlg.GetPathName();
		if (m_strPath.Right(4) != ".txt")
		{
			m_strPath += ".txt";
		}
		file.Open(m_strPath, CFile::modeCreate | CFile::modeReadWrite, &ex);
		// Ʈ ڽ ִ  Ѵ. 
		UpdateData(TRUE);
		file.WriteString(m_strEdit1);
		// Ѵ. 
		file.Close();
	}
}

void CBayesianDensityDlg::OnBnClickedBtnSave2()
{
	printf("[OnBnClickedBtnSave2] \n");
	CString m_strPath;
	CStdioFile file;
	// CFile file;
	CFileException ex;
	CFileDialog dlg(FALSE, _T("*.txt"), NULL, OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT, _T("TXT Files(*.txt)|*.txt|"), NULL);
	if (dlg.DoModal() == IDOK)
	{
		m_strPath = dlg.GetPathName();
		if (m_strPath.Right(4) != ".txt")
		{
			m_strPath += ".txt";
		}
		file.Open(m_strPath, CFile::modeCreate | CFile::modeReadWrite, &ex);
		// Ʈ ڽ ִ  Ѵ. 
		UpdateData(TRUE);
		file.WriteString(m_strEdit2);
		// Ѵ. 
		file.Close();
	}
}


void CBayesianDensityDlg::OnBnClickedBtnClose()
{
	printf("[OnBnClickedBtnClose] \n");
	OnClose();
}



// Ʈڽ  ߰Ѵ. 
void CBayesianDensityDlg::OnBnClickedBtnAdd2edit1()
{
	printf("[OnBnClickedBtnAdd2edit1] \n");
	UpdateData(TRUE);
	CString temp = m_editAdd2Edit1 + "\r\n";
	printf_edit1(temp);
}
void CBayesianDensityDlg::OnBnClickedBtnAdd2edit2()
{
	printf("[OnBnClickedBtnAdd2edit2] \n");
	UpdateData(TRUE);
	CString temp = m_editAdd2Edit2 + "\r\n";
	printf_edit2(temp);
}


// EDIT BOX 1 ʱȭѴ. 
void CBayesianDensityDlg::OnBnClickedBtnResetEdit1()
{
	printf("[OnBnClickedBtnResetEdit1] \n");
	reset_edit1();
}

// EDIT BOX 2 ʱȭѴ. 
void CBayesianDensityDlg::OnBnClickedBtnResetEdit2()
{
	printf("[OnBnClickedBtnResetEdit2] \n");
	reset_edit2();
}


// **********************************************************************************

void CBayesianDensityDlg::OnMouseMove(UINT nFlags, CPoint point)
{
	m_pMousePt.x = point.x;
	m_pMousePt.y = point.y;
	CDialogEx::OnMouseMove(nFlags, point);
}


BOOL CBayesianDensityDlg::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	bool b = FALSE;

	if (m_pMousePt.x >= stage1_left && m_pMousePt.x <= stage1_right && m_pMousePt.y >= stage1_top && m_pMousePt.y <= stage1_btm)
	{
		if (zDelta>0)
		{
			stage1_view_zoom += 0.05;
			b = TRUE;
		}
		else
		{
			stage1_view_zoom -= 0.05;
			if (stage1_view_zoom<0.01)	stage1_view_zoom = 0.01;
			b = TRUE;
		}
		printf("stage1_view_zoom: %.2f \n", stage1_view_zoom);
	}
	else if (m_pMousePt.x >= stage2_left && m_pMousePt.x <= stage2_right && m_pMousePt.y >= stage2_top && m_pMousePt.y <= stage2_btm)
	{
		if (zDelta>0)
		{
			stage2_view_zoom += 0.05;
			b = TRUE;
		}
		else
		{
			stage2_view_zoom -= 0.05;
			if (stage2_view_zoom<0.01)	stage2_view_zoom = 0.01;
			b = TRUE;
		}
		printf("stage2_view_zoom: %.2f \n", stage2_view_zoom);
	}
	if (b)
	{
		Invalidate();
		return TRUE;
	}
	return CDialogEx::OnMouseWheel(nFlags, zDelta, pt);
}


BOOL CBayesianDensityDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		printf("[PreTranslateMessage] msg: %d \n", pMsg->wParam);
		// ESC   ó 
		if (pMsg->wParam == 27)
		{// 27: esc ǹѴ. 
			OnClose();
			return FALSE;
		}
		// Edit Box Ű óϱ (console ø Ŀ editbox ʱȭ)
		if (pMsg->wParam == VK_RETURN && GetDlgItem(IDC_EDIT_INPUT2EDIT1) == GetFocus())
		{
			OnBnClickedBtnAdd2edit1();
			m_editAdd2Edit1.Format(_T(""));
			UpdateData(FALSE);
			return TRUE;
		}
		if (pMsg->wParam == VK_RETURN && GetDlgItem(IDC_EDIT_INPUT2EDIT2) == GetFocus())
		{
			OnBnClickedBtnAdd2edit2();
			m_editAdd2Edit2.Format(_T(""));
			UpdateData(FALSE);
			return TRUE;
		}

	}

	// ***********************************************************************************************************************
	//								Ʒʹ stage Ű ׸ ̵ õ ̴. 
	// ***********************************************************************************************************************
	bool r = FALSE;
	if (m_pMousePt.x >= stage1_left && m_pMousePt.x <= stage1_right && m_pMousePt.y >= stage1_top && m_pMousePt.y <= stage1_btm)
	{
		if (pMsg->message == WM_KEYDOWN)
		{
			TRACE("Ű ȴ: %d \r\n", pMsg->wParam);
			switch (pMsg->wParam)
			{
			case 104:
			case VK_UP:
				stage1_view_offset_y -= 25;
				r = TRUE;
				break;
			case 98:
			case VK_DOWN:
				stage1_view_offset_y += 25;
				r = TRUE;
				break;
			case 102:
			case VK_RIGHT:
				stage1_view_offset_x += 25;
				r = TRUE;
				break;
			case 100:
			case VK_LEFT:
				stage1_view_offset_x -= 25;
				r = TRUE;
				break;
			}

			// ׸ ٽ ׸. 
			if (r){
				printf("(stage1_view_offset_x, stage1_view_offset_y) = (%d, %d) \n"
					, stage1_view_offset_x, stage1_view_offset_y);
				Invalidate(FALSE);
				return TRUE;
			}
		}
	}
	// ***********************************************************************************************************************
	if (m_pMousePt.x >= stage2_left && m_pMousePt.x <= stage2_right && m_pMousePt.y >= stage2_top && m_pMousePt.y <= stage2_btm)
	{
		if (pMsg->message == WM_KEYDOWN)
		{
			TRACE("Ű ȴ: %d \r\n", pMsg->wParam);
			switch (pMsg->wParam)
			{
			case 104:
			case VK_UP:
				stage2_view_offset_y -= 25;
				r = TRUE;
				break;
			case 98:
			case VK_DOWN:
				stage2_view_offset_y += 25;
				r = TRUE;
				break;
			case 102:
			case VK_RIGHT:
				stage2_view_offset_x += 25;
				r = TRUE;
				break;
			case 100:
			case VK_LEFT:
				stage2_view_offset_x -= 25;
				r = TRUE;
				break;
			}

			// ׸ ٽ ׸. 
			if (r){
				printf("(stage2_view_offset_x, stage2_view_offset_y) = (%d, %d) \n"
					, stage2_view_offset_x, stage2_view_offset_y);
				Invalidate(FALSE);
				return TRUE;
			}
		}
	}
	return CDialogEx::PreTranslateMessage(pMsg);
}

//  콺 ư Ŭ 
void CBayesianDensityDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	if (m_pMousePt.x >= stage1_left && m_pMousePt.x <= stage1_right && m_pMousePt.y >= stage1_top && m_pMousePt.y <= stage1_btm)
	{
		point_lclk = CPoint(point.x, point.y);
		CPoint stagePoint = _iP1(point_lclk);
		printf("L btn down (%d, %d) => stage point (%d, %d) \n", point_lclk.x, point_lclk.y, stagePoint.x, stagePoint.y);
		CString str;
		str.Format(_T("stage1 pnt: (%d, %d)\r\n"), stagePoint.x, stagePoint.y);
		printf_edit1(str);
		// addDebugingPoint1(stagePoint.x, stagePoint.y);
		// ׸ updateѴ. 
		Invalidate();
	}
	if (m_pMousePt.x >= stage2_left && m_pMousePt.x <= stage2_right && m_pMousePt.y >= stage2_top && m_pMousePt.y <= stage2_btm)
	{
		point_lclk = CPoint(point.x - stage2_offset_x, point.y);
		CPoint stagePoint = _iP2(point_lclk);
		printf("L btn down (%d, %d) => stage point (%d, %d) \n", point_lclk.x, point_lclk.y, stagePoint.x, stagePoint.y);
		CString str;
		str.Format(_T("stage2 pnt: (%d, %d)\r\n"), stagePoint.x, stagePoint.y);
		printf_edit1(str);
		// addDebugingPoint2(stagePoint.x, stagePoint.y);
		// ׸ updateѴ. 
		Invalidate();
	}
	CDialogEx::OnLButtonDown(nFlags, point);
}


void CBayesianDensityDlg::OnRButtonDown(UINT nFlags, CPoint point)
{
	if (m_pMousePt.x >= stage1_left && m_pMousePt.x <= stage1_right && m_pMousePt.y >= stage1_top && m_pMousePt.y <= stage1_btm)
	{
		point_rclk = CPoint(point.x , point.y);
		CPoint stagePoint = _iP1(point_rclk);
		TRACE("R btn down (%d, %d) => stage point (%d, %d) \n", point_rclk.x, point_rclk.y, stagePoint.x, stagePoint.y);
		if (m_nDrawCnt1 > 0) m_nDrawCnt1 = m_nDrawCnt1 - 1;
		// ׸ updateѴ. 
		Invalidate();
	}
	if (m_pMousePt.x >= stage2_left && m_pMousePt.x <= stage2_right && m_pMousePt.y >= stage2_top && m_pMousePt.y <= stage2_btm)
	{
		point_rclk = CPoint(point.x, point.y);
		CPoint stagePoint = _iP2(point_rclk);
		TRACE("R btn down (%d, %d) => stage point (%d, %d) \n", point_rclk.x, point_rclk.y, stagePoint.x, stagePoint.y);
		if (m_nDrawCnt2 > 0) m_nDrawCnt2 = m_nDrawCnt2 - 1;
		// ׸ updateѴ. 
		Invalidate();
	}
	CDialogEx::OnRButtonDown(nFlags, point);
}



// Default parameter   
void CBayesianDensityDlg::OnBnClickedCheck1()
{
	// Default parameter   edit box read only . 
	if (param->dft)
	{
		param->dft = false;
		printf("Dont use default parameter \n");
		GetDlgItem(IDC_EDIT_INPUT_u)->SendMessage(EM_SETREADONLY, 0, 0);
		GetDlgItem(IDC_EDIT_INPUT_uc)->SendMessage(EM_SETREADONLY, 0, 0);
		GetDlgItem(IDC_EDIT_INPUT_w)->SendMessage(EM_SETREADONLY, 0, 0);
		GetDlgItem(IDC_EDIT_INPUT_wc)->SendMessage(EM_SETREADONLY, 0, 0);
		GetDlgItem(IDC_EDIT_INPUT_s)->SendMessage(EM_SETREADONLY, 0, 0);
		GetDlgItem(IDC_EDIT_INPUT_sc)->SendMessage(EM_SETREADONLY, 0, 0);
		GetDlgItem(IDC_EDIT_INPUT_a)->SendMessage(EM_SETREADONLY, 0, 0);
		GetDlgItem(IDC_EDIT_INPUT_b)->SendMessage(EM_SETREADONLY, 0, 0);
		GetDlgItem(IDC_EDIT_INPUT_m)->SendMessage(EM_SETREADONLY, 0, 0);
		GetDlgItem(IDC_EDIT_INPUT_tau)->SendMessage(EM_SETREADONLY, 0, 0);
	}
	else
	{
		param->dft = true;
		printf("Use default parameter \n");
		GetDlgItem(IDC_EDIT_INPUT_u)->SendMessage(EM_SETREADONLY, 1, 0);
		GetDlgItem(IDC_EDIT_INPUT_uc)->SendMessage(EM_SETREADONLY, 1, 0);
		GetDlgItem(IDC_EDIT_INPUT_w)->SendMessage(EM_SETREADONLY, 1, 0);
		GetDlgItem(IDC_EDIT_INPUT_wc)->SendMessage(EM_SETREADONLY, 1, 0);
		GetDlgItem(IDC_EDIT_INPUT_s)->SendMessage(EM_SETREADONLY, 1, 0);
		GetDlgItem(IDC_EDIT_INPUT_sc)->SendMessage(EM_SETREADONLY, 1, 0);
		GetDlgItem(IDC_EDIT_INPUT_a)->SendMessage(EM_SETREADONLY, 1, 0);
		GetDlgItem(IDC_EDIT_INPUT_b)->SendMessage(EM_SETREADONLY, 1, 0);
		GetDlgItem(IDC_EDIT_INPUT_m)->SendMessage(EM_SETREADONLY, 1, 0);
		GetDlgItem(IDC_EDIT_INPUT_tau)->SendMessage(EM_SETREADONLY, 1, 0);
	}
}

// 
void CBayesianDensityDlg::OnBnClickedCheck2()
{
	UpdateData(false);
	if (IsDlgButtonChecked(IDC_CHECK2))
	{
		param->learn_a = true;
		printf("Sample alpha \n");
	}
	else
	{
		param->learn_a = false;
		printf("Dont sample alpha \n");
	}
	/*
	if (param->learn_a)
	{
		param->learn_a = false;
		printf("Dont sample alpha \n");
		CheckDlgButton(IDC_CHECK2, 0);
	}
	else
	{
		param->learn_a = true;
		printf("Sample alpha \n");
		CheckDlgButton(IDC_CHECK2, 0);
	}
	*/
}
void CBayesianDensityDlg::OnBnClickedCheck3()
{
	UpdateData(false);
	if (IsDlgButtonChecked(IDC_CHECK3))
	{
		param->learn_m = true;
		printf("Sample m \n");
	}
	else
	{
		param->learn_m = false;
		printf("Dont sample m \n");
	}
	/*
	if (param->learn_m)
	{
		param->learn_m = false;
		printf("Dont sample m \n");
	}
	else
	{
		param->learn_m = true;
		printf("Sample m \n");
	}
	*/
}

void CBayesianDensityDlg::OnBnClickedCheck4()
{
	if (flag4)
	{
		flag4 = false;
		printf("Check 4 OFF \n");
		// Edit box2 . 
		CString temp; temp.Format(_T("Check 4 OFF \r\n"));
		printf_edit2(temp);
	}
	else
	{
		flag4 = true;
		printf("Check 4 ON \n");
		// Edit box2 . 
		CString temp; temp.Format(_T("Check 4 ON \r\n"));
		printf_edit2(temp);
	}
}

